searchNodes=[{"ref":"Membrane.Element.Tee.Master.html","title":"Membrane.Element.Tee.Master","type":"module","doc":"Element for forwarding buffers to at least one output pad It has one input pad :input and 2 output pads: :master - is a static pad which is always available and works in pull mode :copy - is a dynamic pad that can be linked to any number of elements (including 0) and works in push mode The :master pad dictates the speed of processing data and any element (or elements) connected to :copy pad will receive the same data as :master Pads :input Availability:always Caps:any Demand&nbsp;unit:buffers Direction:input Mode:pull :copy Availability:on_request Caps:any Direction:output Mode:push :master Availability:always Caps:any Direction:output Mode:pull"},{"ref":"Membrane.Element.Tee.Master.html#membrane_pads/0","title":"Membrane.Element.Tee.Master.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.Tee.Master"},{"ref":"Membrane.Element.Tee.Parallel.html","title":"Membrane.Element.Tee.Parallel","type":"module","doc":"Element for forwarding packets to two or more outputs There is one input pad :input and output pad: :output - is a dynamic pad which is available on request and works in pull mode Basically we can forward packets to more than one destination by linking dynamic pad to one or more inputs. Packets are forwarded only when all output pads send demands. To avoid overriding your links to output pads, create them with specific id ({:tee, :output, id}) Pads :input Availability:always Caps:any Demand&nbsp;unit:buffers Direction:input Mode:pull :output Availability:on_request Caps:any Direction:output Mode:pull"},{"ref":"Membrane.Element.Tee.Parallel.html#membrane_pads/0","title":"Membrane.Element.Tee.Parallel.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.Tee.Parallel"},{"ref":"readme.html","title":"Membrane Multimedia Framework: Tee","type":"extras","doc":"Membrane Multimedia Framework: Tee This package provides elements that can be used to branch stream processing in pipeline, e.g. send data from one source to two or more sinks."},{"ref":"readme.html#installation","title":"Membrane Multimedia Framework: Tee - Installation","type":"extras","doc":"This package can be installed by adding membrane_element_tee to your list of dependencies in mix.exs: def deps do [ {:membrane_element_tee, &quot;~&gt; 0.2.0&quot;} ] end The docs can be found at HexDocs."},{"ref":"readme.html#examples","title":"Membrane Multimedia Framework: Tee - Examples","type":"extras","doc":"Membrane.Element.Tee.Parallel This element has dynamic :output pads working in :pull mode. Packets are forwarded only when all output pads send demands, which means that the slowest output pad dictates the speed of processing data. Playing this pipeline should result in copying the source file to all destination files (sinks). Before playing it, make sure that the source file exists, e.g. like this: echo &quot;Membrane Framework is cool&quot; &gt; /tmp/source_text_file You also need :membrane_element_file in project dependencies to run this pipeline. defmodule FileMultiForwardPipeline do use Membrane.Pipeline alias Pipeline.Spec alias Membrane.Element.{File, Tee} @impl true def handle_init(_) do children = [ file_src: %File.Source{location: &quot;tmp/source_text_file&quot;}, tee: Tee.Parallel, file_sink1: %File.Sink{location: &quot;/tmp/destination_file1&quot;}, file_sink2: %File.Sink{location: &quot;/tmp/destination_file2&quot;}, ] links = %{ {:file_src, :output} =&gt; {:tee, :input}, {:tee, :output, 1} =&gt; {:file_sink1, :input}, {:tee, :output, 2} =&gt; {:file_sink2, :input}, } {{:ok, %Spec{children: children, links: links}}, %{}} end end Membrane.Element.Tee.Master This element has one :master output pad that dictates the speed of processing data and dynamic :copy pad working in :push mode mirroring :master pad. Playing this pipeline should result in playing mp3 source file and copying it to the destination file. Before playing it, make sure you have valid source file, e.g. this one. You also need :membrane_element_file and :membrane_element_portaudio in project dependencies to run this pipeline. defmodule AudioPlayAndCopyPipeline do use Membrane.Pipeline alias Pipeline.Spec alias Membrane.Element.{File, Tee, PortAudio} @impl true def handle_init(_) do children = [ file_src: %File.Source{location: &quot;/tmp/source_file.mp3&quot;}, tee: Tee.Master, audio_sink: Membrane.Element.PortAudio.Sink, file_sink: %File.Sink{location: &quot;/tmp/destination_file.mp3&quot;}, ] links = %{ {:file_src, :output} =&gt; {:tee, :input}, {:tee, :master} =&gt; {:audio_sink, :input}, {:tee, :copy} =&gt; {:file_sink, :input}, } {{:ok, %Spec{children: children, links: links}}, %{}} end end"},{"ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework: Tee - Copyright and License","type":"extras","doc":"Copyright 2019, Software Mansion Licensed under the Apache License, Version 2.0"}]